## nanoflann 1.3.2+ds

=== CMakeLists.txt ===
# ----------------------------------------------------------------------------
# Root CMake file for nanoflann
# ----------------------------------------------------------------------------
cmake_minimum_required(VERSION 3.1)

# Extract library version into "NANOFLANN_VERSION"
# -----------------------------------------------------
# Look for: "#define NANOFLANN_VERSION 0xABC"
file(READ "${CMAKE_CURRENT_SOURCE_DIR}/include/nanoflann.hpp" STR_HPP)
string(REGEX MATCHALL "NANOFLANN_VERSION.*0x[0-9,A-F]+" CMAKE_VERSION_LINE "${STR_HPP}")
string(REGEX MATCHALL "0x[0-9,A-F]+" NANOFLANN_VERSION_HEX "${CMAKE_VERSION_LINE}")

string(REGEX REPLACE "0x(.).*" "\\1" NANOFLANN_VERSION_MAJOR "${NANOFLANN_VERSION_HEX}" )
string(REGEX REPLACE "0x.(.).*" "\\1" NANOFLANN_VERSION_MINOR "${NANOFLANN_VERSION_HEX}" )
string(REGEX REPLACE "0x..(.).*" "\\1" NANOFLANN_VERSION_PATCH "${NANOFLANN_VERSION_HEX}" )
mark_as_advanced(STR_HPP CMAKE_VERSION_LINE NANOFLANN_VERSION_HEX NANOFLANN_VERSION_MAJOR NANOFLANN_VERSION_MINOR NANOFLANN_VERSION_PATCH)

project(nanoflann VERSION "${NANOFLANN_VERSION_MAJOR}.${NANOFLANN_VERSION_MINOR}.${NANOFLANN_VERSION_PATCH}")

message(STATUS "nanoflann version: ${NANOFLANN_VERSION_MAJOR}.${NANOFLANN_VERSION_MINOR}.${NANOFLANN_VERSION_PATCH}")
file(WRITE "${nanoflann_BINARY_DIR}/version" "${NANOFLANN_VERSION_MAJOR}.${NANOFLANN_VERSION_MINOR}.${NANOFLANN_VERSION_PATCH}")


# Compiler options:
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Enable a high level of warnings.
if (CMAKE_COMPILER_IS_GNUCXX)
	# The -Wno-long-long is required in 64bit systems when including sytem headers.
	# The -Wno-variadic-macros was needed for Eigen3, StdVector.h
	add_compile_options(-Wall -Wno-long-long -Wno-variadic-macros -O2 -mtune=native)
	# Workaround: Eigen <3.4 produces *tons* of warnings in GCC >=6. See http://eigen.tuxfamily.org/bz/show_bug.cgi?id=1221
	if (NOT ${CMAKE_CXX_COMPILER_VERSION} LESS "6.0")
		add_compile_options(-Wno-ignored-attributes -Wno-int-in-bool-context)
	endif()
endif()

if(MSVC)
	 add_definitions( "/W3 /D_CRT_SECURE_NO_WARNINGS /nologo" )
endif()

# Solution Folder options:
set_property(GLOBAL PROPERTY USE_FOLDERS ON)
set_property(GLOBAL PROPERTY PREDEFINED_TARGETS_FOLDER "CMakeTargets")

add_definitions ( -DNANOFLANN_PATH="${CMAKE_SOURCE_DIR}" )


include(GNUInstallDirs)
# Set relative install directories
set(INSTALL_INCLUDE_DIR "${CMAKE_INSTALL_INCLUDEDIR}")
set(INSTALL_PKGCONFIG_DIR "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
set(INSTALL_CMAKE_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}")
set(INSTALL_COPYRIGHT_DIR "${CMAKE_INSTALL_DOCDIR}")


# Define nanoflann lib (header-only)
add_library(nanoflann INTERFACE)

target_include_directories(nanoflann
	INTERFACE
		$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
		$<INSTALL_INTERFACE:${INSTALL_INCLUDE_DIR}>)

install(TARGETS nanoflann
        EXPORT nanoflannTargets)

add_library(nanoflann::nanoflann ALIAS nanoflann)

# Examples
option(BUILD_EXAMPLES "Build examples" ON)
if(BUILD_EXAMPLES)
	add_subdirectory(examples)
endif()

# Benchmarks
option(BUILD_BENCHMARKS "Build benchmarks" OFF)
if(BUILD_BENCHMARKS)
        # 3rdparty Libraries
        include(3rdparty/CMakeLists-flann.txt)
        include(3rdparty/CMakeLists-fastann.txt)
        include(3rdparty/CMakeLists-libkdtree.txt)
	add_subdirectory(benchmarkTool)
endif()

# Tests
option(BUILD_TESTS "Build unit tests" ON)
if(BUILD_TESTS)
	enable_testing()
	add_subdirectory(tests)
endif()

# --------------------------------------------------------------------
# Install/uninstall targets
# --------------------------------------------------------------------

#--------------------------------------------------------------
# If we are building the final step of the Debian package,
#  save each library files in the corresponding directories:
#--------------------------------------------------------------
if(CMAKE_USE_DEB_POSTFIXS)
	# Values when building a Debian package ---------------
	message(STATUS "** Using Debian post-fix for install directories **")
	set(libnanoflann_dev_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}/libnanoflann-dev/usr/")
	set(nanoflann_pkgconfig_INSTALL_PREFIX "/usr")	# Values when building a Debian package
ELSE()
	# Values under normal conditions -----------------------
	set(libnanoflann_dev_INSTALL_PREFIX "")
	set(nanoflann_pkgconfig_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}") 	# Values under normal conditions
endif()

# Generate the pkg-config file:
configure_file(
	"${nanoflann_SOURCE_DIR}/scripts/nanoflann.pc.in"
	"${nanoflann_BINARY_DIR}/nanoflann.pc" @ONLY IMMEDIATE )



# Generate the cmake config and cmake config-version file:
include(CMakePackageConfigHelpers)

configure_package_config_file(
    "${nanoflann_SOURCE_DIR}/scripts/nanoflannConfig.cmake.in"
    "${nanoflann_BINARY_DIR}/nanoflannConfig.cmake"
    INSTALL_DESTINATION ${INSTALL_CMAKE_DIR}
    PATH_VARS INSTALL_INCLUDE_DIR)

# Setting CMAKE_SIZEOF_VOID_P to the empty string has the same
# effect as the ARCH_INDEPENDENT option of
# write_basic_package_version_file(), but works with older CMake
# versions before 3.14
set(backup_of_CMAKE_SIZEOF_VOID_P "${CMAKE_SIZEOF_VOID_P}")
set(CMAKE_SIZEOF_VOID_P "")

write_basic_package_version_file(
    "${nanoflann_BINARY_DIR}/nanoflannConfigVersion.cmake"
    VERSION ${nanoflann_VERSION}
    COMPATIBILITY AnyNewerVersion)

set(CMAKE_SIZEOF_VOID_P "${backup_of_CMAKE_SIZEOF_VOID_P}")

# Uninstall target, for "make uninstall"
configure_file(
  "${nanoflann_SOURCE_DIR}/scripts/cmake_uninstall.cmake.in"
  "${nanoflann_BINARY_DIR}/cmake_uninstall.cmake"
  @ONLY IMMEDIATE)

add_custom_target(uninstall
  "${CMAKE_COMMAND}" -P "${nanoflann_BINARY_DIR}/cmake_uninstall.cmake")


export(EXPORT nanoflannTargets
       NAMESPACE nanoflann::
       FILE "${nanoflann_BINARY_DIR}/nanoflannTargets.cmake")

export(PACKAGE nanoflann)

install(EXPORT nanoflannTargets
        NAMESPACE nanoflann::
        DESTINATION "${libnanoflann_dev_INSTALL_PREFIX}${INSTALL_CMAKE_DIR}")

install(
	FILES "${nanoflann_BINARY_DIR}/nanoflann.pc"
	DESTINATION "${libnanoflann_dev_INSTALL_PREFIX}${INSTALL_PKGCONFIG_DIR}" )

install(
    FILES "${nanoflann_BINARY_DIR}/nanoflannConfig.cmake"
          "${nanoflann_BINARY_DIR}/nanoflannConfigVersion.cmake"
    DESTINATION "${libnanoflann_dev_INSTALL_PREFIX}${INSTALL_CMAKE_DIR}" )

install(
	FILES "${nanoflann_SOURCE_DIR}/include/nanoflann.hpp"
	DESTINATION "${libnanoflann_dev_INSTALL_PREFIX}${INSTALL_INCLUDE_DIR}" )

if(CMAKE_USE_DEB_POSTFIXS)
	install(
		FILES "${nanoflann_SOURCE_DIR}/copyright"
		DESTINATION "${libnanoflann_dev_INSTALL_PREFIX}${INSTALL_COPYRIGHT_DIR}" )
endif()

=== examples/CMakeLists.txt ===
find_package(Eigen3 QUIET)

# examples:
MACRO(DEFINE_EXAMPLE _NAME)
	ADD_EXECUTABLE(${_NAME} ${_NAME}.cpp)
	set_target_properties(${_NAME} PROPERTIES FOLDER "Examples")
	TARGET_LINK_LIBRARIES(${_NAME} nanoflann::nanoflann)  # adds the "#include" directory.
  install(TARGETS ${_NAME}
          DESTINATION examples)
ENDMACRO()

DEFINE_EXAMPLE(dynamic_pointcloud_example)
DEFINE_EXAMPLE(pointcloud_example)
DEFINE_EXAMPLE(pointcloud_kdd_radius)
DEFINE_EXAMPLE(pointcloud_adaptor_example)
DEFINE_EXAMPLE(SO3_adaptor_example)
DEFINE_EXAMPLE(SO2_adaptor_example)
DEFINE_EXAMPLE(saveload_example)
DEFINE_EXAMPLE(vector_of_vectors_example)

IF(EIGEN3_FOUND)
	DEFINE_EXAMPLE(matrix_example)
    target_include_directories (matrix_example PRIVATE ${EIGEN3_INCLUDE_DIR})
ENDIF()

=== tests/CMakeLists.txt ===
# ----------------------------------------------------------------------------
#   TESTS
# ----------------------------------------------------------------------------
PROJECT(tests)

# Fix a "bug" in VS11 (MSVC 2012):
if(MSVC)
	add_definitions(-D_VARIADIC_MAX=10)
endif(MSVC)

if(NOT TARGET gtest)
	# Treat this directory as "system" to ignore pedantic warnings.
	if(CMAKE_COMPILER_IS_GNUCXX)
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -isystem gtest-1.8.0/include")
	endif()

	# Compile gtest from sources:
	add_subdirectory(gtest-1.8.0)
	INCLUDE_DIRECTORIES("gtest-1.8.0/include/")
endif()

set(EXECUTABLE_OUTPUT_PATH "${${PROJECT_NAME}_BINARY_DIR}")

# Tests based on Google gtest:
# -----------------------------

# If using system library, add C++ flags:
if (UNIX)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread")
endif()

# Test project:
ADD_EXECUTABLE(unit_tests test_main.cpp)
set_target_properties(unit_tests PROPERTIES FOLDER "./")
ADD_TEST(unit_tests_build "${CMAKE_COMMAND}" --build ${CMAKE_BINARY_DIR} --target unit_tests)
ADD_TEST(unit_tests_run ${EXECUTABLE_OUTPUT_PATH}/unit_tests)
set_tests_properties(unit_tests_run PROPERTIES DEPENDS unit_tests_build)

# Add the required libraries for linking:
TARGET_LINK_LIBRARIES(unit_tests mygtest nanoflann)

=== benchmarkTool/randomTests/CMakeLists.txt ===
ADD_EXECUTABLE(benchmark_nanoflann_random benchmark_nanoflann_random.cpp)
TARGET_LINK_LIBRARIES(benchmark_nanoflann_random nanoflann::nanoflann)
ADD_DEPENDENCIES(benchmarks benchmark_nanoflann_random)

set(flann_INCLUDE_DIRS "${CMAKE_SOURCE_DIR}/3rdparty/flann/src/cpp")
include_directories(${flann_INCLUDE_DIRS})
set(flann_LIBRARIES "${CMAKE_SOURCE_DIR}/build/flann-prefix/src/flann-build/lib/libflann_cpp.so")
ADD_EXECUTABLE(benchmark_flann_random benchmark_flann_random.cpp)
ADD_DEPENDENCIES(benchmark_flann_random flann)
TARGET_LINK_LIBRARIES(benchmark_flann_random nanoflann::nanoflann ${flann_LIBRARIES})
ADD_DEPENDENCIES(benchmarks benchmark_flann_random)

set(fastann_INCLUDE_DIRS "${CMAKE_SOURCE_DIR}/3rdparty/fastann")
include_directories(${fastann_INCLUDE_DIRS})
set(fastann_LIBRARIES "${CMAKE_SOURCE_DIR}/build/fastann-prefix/src/fastann-build/libfastann.so")
ADD_EXECUTABLE(benchmark_fastann_random benchmark_fastann_random.cpp)
ADD_DEPENDENCIES(benchmark_fastann_random fastann)
TARGET_LINK_LIBRARIES(benchmark_fastann_random nanoflann::nanoflann ${fastann_LIBRARIES})
ADD_DEPENDENCIES(benchmarks benchmark_fastann_random)

set(libkdtree_INCLUDE_DIRS "${CMAKE_SOURCE_DIR}/3rdparty/libkdtree")
include_directories(${libkdtree_INCLUDE_DIRS})
ADD_EXECUTABLE(benchmark_libkdtree_random benchmark_libkdtree_random.cpp)
ADD_DEPENDENCIES(benchmark_libkdtree_random libkdtree)
set_target_properties(benchmark_nanoflann_random benchmark_flann_random benchmark_fastann_random benchmark_libkdtree_random PROPERTIES FOLDER "RandomTests")
ADD_DEPENDENCIES(benchmarks benchmark_nanoflann_random)

=== benchmarkTool/realTests/CMakeLists.txt ===
ADD_EXECUTABLE(benchmark_nanoflann_real benchmark_nanoflann_real.cpp)
TARGET_LINK_LIBRARIES(benchmark_nanoflann_real nanoflann::nanoflann)
ADD_DEPENDENCIES(benchmarks benchmark_nanoflann_real)


set(flann_INCLUDE_DIRS "${CMAKE_SOURCE_DIR}/3rdparty/flann/src/cpp")
include_directories(${flann_INCLUDE_DIRS})
set(flann_LIBRARIES "${CMAKE_SOURCE_DIR}/build/flann-prefix/src/flann-build/lib/libflann_cpp.so")
ADD_EXECUTABLE(benchmark_flann_real benchmark_flann_real.cpp)
TARGET_LINK_LIBRARIES(benchmark_flann_real nanoflann::nanoflann ${flann_LIBRARIES})
ADD_DEPENDENCIES(benchmark_flann_real flann)
ADD_DEPENDENCIES(benchmarks benchmark_flann_real)

set(fastann_INCLUDE_DIRS "${CMAKE_SOURCE_DIR}/3rdparty/fastann")
include_directories(${fastann_INCLUDE_DIRS})
set(fastann_LIBRARIES "${CMAKE_SOURCE_DIR}/build/fastann-prefix/src/fastann-build/libfastann.so")
ADD_EXECUTABLE(benchmark_fastann_real benchmark_fastann_real.cpp)
TARGET_LINK_LIBRARIES(benchmark_fastann_real nanoflann::nanoflann ${fastann_LIBRARIES})
ADD_DEPENDENCIES(benchmark_fastann_real fastann)
ADD_DEPENDENCIES(benchmarks benchmark_fastann_real)

set(libkdtree_INCLUDE_DIRS "${CMAKE_SOURCE_DIR}/3rdparty/libkdtree")
include_directories(${libkdtree_INCLUDE_DIRS})
ADD_EXECUTABLE(benchmark_libkdtree_real benchmark_libkdtree_real.cpp)
set_target_properties(benchmark_nanoflann_real benchmark_flann_real benchmark_fastann_real benchmark_libkdtree_real PROPERTIES FOLDER "RealTests")
ADD_DEPENDENCIES(benchmark_libkdtree_real libkdtree)
ADD_DEPENDENCIES(benchmarks benchmark_libkdtree_real)

=== perf-tests/flann/Makefile ===
# Set up basic variables:
CC         = g++
CFLAGS     = -c -Wall -O2 -mtune=native
LDFLAGS    =

# List of sources:
SOURCES    = test_flann.cpp
OBJECTS    = $(SOURCES:.cpp=.o)

# Name of executable target:
EXECUTABLE = test_flann

CFLAGS     += `pkg-config --cflags flann`
#LDFLAGS    += `pkg-config --libs flann`
LDFLAGS    += -lflann_cpp

all: $(SOURCES) $(EXECUTABLE)
	
$(EXECUTABLE): $(OBJECTS)
	$(CC) $(LDFLAGS) $(OBJECTS) -o $@

.cpp.o:
	$(CC) $(CFLAGS) $< -o $@

clean:
	rm $(OBJECTS) $(EXECUTABLE)

=== debian/changelog ===
nanoflann (1.3.2+ds-1) unstable; urgency=medium

  * [83c50bc] Add Multi-Arch: foreign to libnanoflann-dev
  * [cc54689] New upstream version 1.3.2+ds
  * [d1c6c6d] Update patches
    - Update patch to install nanonflann architecture-independently
    - New patch to set target compile features instead of CXX_STANDARD

 -- Timo Röhling <timo@gaussglocke.de>  Thu, 05 Nov 2020 10:48:40 +0100

nanoflann (1.3.1+ds-2) unstable; urgency=medium

  * Team upload.
  * source only upload

 -- Jochen Sprickerhof <jspricke@debian.org>  Tue, 03 Nov 2020 09:11:07 +0100

nanoflann (1.3.1+ds-1) unstable; urgency=medium

  * Package split from MRPT.
    This is the first release as stand-alone library, which is
    intended to replace libmrpt-nanoflann-dev.
    Released with the MRPT maintainer's consent.

 -- Timo Röhling <timo@gaussglocke.de>  Sun, 01 Nov 2020 11:56:12 +0100

=== debian/control ===
Source: nanoflann
Section: libs
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Timo Röhling <timo@gaussglocke.de>, José Luis Blanco Claraco <joseluisblancoc@gmail.com>
Build-Depends: debhelper-compat (= 13), cmake, libgtest-dev <!nocheck>, doxygen <!nodoc>
Homepage: https://github.com/jlblancoc/nanoflann
Standards-Version: 4.5.0
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/science-team/nanoflann.git
Vcs-Browser: https://salsa.debian.org/science-team/nanoflann

Package: libnanoflann-dev
Section: libdevel
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: C++11 header-only library for Nearest Neighbor Search with KD-Trees
 Nanoflann is a fork of the FLANN library. Originally born as a child project
 of the Mobile Robot Programming Toolkit, nanoflann is now available as
 stand-alone library.
 .
 It trades some of the flexibility of FLANN for raw execution speed and is much
 more memory efficient, as it avoids unnecessary copies of point cloud data.

=== debian/rules ===
#!/usr/bin/make -f

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
BUILD_TESTS=ON
else
BUILD_TESTS=OFF
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBUILD_EXAMPLES=OFF \
		-DBUILD_BENCHMARKS=OFF \
		-DBUILD_TESTS=$(BUILD_TESTS)

execute_after_dh_auto_build:
	[ -n "$(filter nodoc,$(DEB_BUILD_OPTIONS))" ] || doxygen

execute_after_dh_installdocs:
	[ -n "$(filter nodoc,$(DEB_BUILD_OPTIONS))" ] || dh_doxygen

## nanoflann 1.4.2%2Bds

=== examples/CMakeLists.txt ===
--- 
+++ 
@@ -5,14 +5,13 @@
 	ADD_EXECUTABLE(${_NAME} ${_NAME}.cpp)
 	set_target_properties(${_NAME} PROPERTIES FOLDER "Examples")
 	TARGET_LINK_LIBRARIES(${_NAME} nanoflann::nanoflann)  # adds the "#include" directory.
-  install(TARGETS ${_NAME}
-          DESTINATION examples)
 ENDMACRO()
 
 DEFINE_EXAMPLE(dynamic_pointcloud_example)
 DEFINE_EXAMPLE(pointcloud_example)
 DEFINE_EXAMPLE(pointcloud_kdd_radius)
 DEFINE_EXAMPLE(pointcloud_adaptor_example)
+DEFINE_EXAMPLE(pointcloud_custom_metric)
 DEFINE_EXAMPLE(SO3_adaptor_example)
 DEFINE_EXAMPLE(SO2_adaptor_example)
 DEFINE_EXAMPLE(saveload_example)

## nanoflann 1.4.2+ds

=== benchmarkTool/CMakeLists.txt ===

ADD_CUSTOM_TARGET(benchmarks)

add_subdirectory(realTests)
add_subdirectory(randomTests)

=== benchmarkTool/randomTests/CMakeLists.txt ===
--- 
+++ 
@@ -1,13 +1,27 @@
 ADD_EXECUTABLE(benchmark_nanoflann_random benchmark_nanoflann_random.cpp)
 TARGET_LINK_LIBRARIES(benchmark_nanoflann_random nanoflann::nanoflann)
 ADD_DEPENDENCIES(benchmarks benchmark_nanoflann_random)
+
+
+# Since flann 1.8.5, LZ4 is vendored. Building against this version fails.
+# This explicitly states to use the system's version of LZ4 instead.
+# See: https://github.com/mariusmuja/flann/issues/384#issuecomment-668782051
+MESSAGE(STATUS "Finding LZ4 libraries")
+FIND_LIBRARY(LZ4_LIBRARIES NAMES liblz4.so HINTS "lz4/lib")
+IF(LZ4_LIBRARIES)
+    MESSAGE(STATUS "Found: ${LZ4_LIBRARIES}")
+    ELSE()
+    MESSAGE(STATUS "Not found: ${LZ4_LIBRARIES}")
+    MESSAGE(FATAL_ERROR "Cannot find required LZ4 libraries")
+ENDIF()
+
 
 set(flann_INCLUDE_DIRS "${CMAKE_SOURCE_DIR}/3rdparty/flann/src/cpp")
 include_directories(${flann_INCLUDE_DIRS})
 set(flann_LIBRARIES "${CMAKE_SOURCE_DIR}/build/flann-prefix/src/flann-build/lib/libflann_cpp.so")
 ADD_EXECUTABLE(benchmark_flann_random benchmark_flann_random.cpp)
 ADD_DEPENDENCIES(benchmark_flann_random flann)
-TARGET_LINK_LIBRARIES(benchmark_flann_random nanoflann::nanoflann ${flann_LIBRARIES})
+TARGET_LINK_LIBRARIES(benchmark_flann_random nanoflann::nanoflann ${flann_LIBRARIES} ${LZ4_LIBRARIES})
 ADD_DEPENDENCIES(benchmarks benchmark_flann_random)
 
 set(fastann_INCLUDE_DIRS "${CMAKE_SOURCE_DIR}/3rdparty/fastann")

=== examples/example_with_cmake/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(pointcloud_example)

# Find nanoflannConfig.cmake:
find_package(nanoflann REQUIRED)

add_executable(${PROJECT_NAME} pointcloud_example.cpp)

# Make sure the include path is used:
target_link_libraries(${PROJECT_NAME} nanoflann::nanoflann)

# for this example to find "../utils.h"
target_include_directories(${PROJECT_NAME} PRIVATE ".")

=== perf-tests/nanoflann/Makefile ===
# Set up basic variables:
CC         = g++
CFLAGS     = -c -Wall -O2 -mtune=native 
LDFLAGS    =

# List of sources:
SOURCES1    = test_nanoflann.cpp
OBJECTS1    = $(SOURCES1:.cpp=.o)

SOURCES2    = test_leaf_max_size.cpp
OBJECTS2    = $(SOURCES2:.cpp=.o)

# Name of executable target:
EXECUTABLE1 = test_nanoflann 

EXECUTABLE2 = test_leaf_max_size


# MRPT specific flags:
#  Here we invoke "pkg-config" passing it as argument the list of the 
#  MRPT libraries needed by our program (see available libs 
#   with "pkg-config --list-all | grep mrpt").
#
#CFLAGS     += `pkg-config --cflags mrpt-base`


all: $(SOURCES) $(EXECUTABLE1) $(EXECUTABLE2)
	
$(EXECUTABLE1): $(OBJECTS1)
	$(CC) $(LDFLAGS) $(OBJECTS1) -o $@

$(EXECUTABLE2): $(OBJECTS2)
	$(CC) $(LDFLAGS) $(OBJECTS2) -o $@

.cpp.o:
	$(CC) $(CFLAGS) $< -o $@

clean:
	rm *.o $(EXECUTABLE1) $(EXECUTABLE2)

=== debian/changelog ===
nanoflann (1.4.2+ds-1) unstable; urgency=medium

  * New upstream version 1.4.2+ds

 -- Timo Röhling <roehling@debian.org>  Wed, 12 Jan 2022 13:54:44 +0100

nanoflann (1.4.1+ds-1) unstable; urgency=medium

  * New upstream version 1.4.1+ds

 -- Timo Röhling <roehling@debian.org>  Sat, 08 Jan 2022 17:36:00 +0100

nanoflann (1.4.0+ds-1) unstable; urgency=medium

  * Update list of excluded files in d/copyright
  * New upstream version 1.4.0+ds
  * Refresh patches.
    Drop CMake buildsystem patches which have been applied upstream.
  * Bump Standards-Version to 4.6.0
  * Update uploader email address

 -- Timo Röhling <roehling@debian.org>  Tue, 04 Jan 2022 10:42:47 +0100

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,10 @@
 Section: libs
 Priority: optional
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Timo Röhling <timo@gaussglocke.de>, José Luis Blanco Claraco <joseluisblancoc@gmail.com>
+Uploaders: Timo Röhling <roehling@debian.org>, José Luis Blanco Claraco <joseluisblancoc@gmail.com>
 Build-Depends: debhelper-compat (= 13), cmake, libgtest-dev <!nocheck>, doxygen <!nodoc>
 Homepage: https://github.com/jlblancoc/nanoflann
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/science-team/nanoflann.git
 Vcs-Browser: https://salsa.debian.org/science-team/nanoflann

## nanoflann 1.4.3%2Bds

=== debian/rules ===
#!/usr/bin/make -f


BUILD_TESTS = $(if $(filter nocheck,$(DEB_BUILD_OPTIONS)),OFF,ON)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DPKGCONFIG_INSTALL_DIR=share/pkgconfig \
		-DNANOFLANN_BUILD_EXAMPLES=OFF \
		-DNANOFLANN_BUILD_BENCHMARKS=OFF \
		-DNANOFLANN_BUILD_TESTS=$(BUILD_TESTS)

execute_after_dh_auto_build:
ifeq ($(filter nodoc,$(DEB_BUILD_OPTIONS)),)
	doxygen
endif

execute_after_dh_installdocs:
ifeq ($(filter nodoc,$(DEB_BUILD_OPTIONS)),)
	dh_doxygen
endif

## nanoflann 1.4.3+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -20,11 +20,6 @@
 message(STATUS "nanoflann version: ${NANOFLANN_VERSION_MAJOR}.${NANOFLANN_VERSION_MINOR}.${NANOFLANN_VERSION_PATCH}")
 file(WRITE "${nanoflann_BINARY_DIR}/version" "${NANOFLANN_VERSION_MAJOR}.${NANOFLANN_VERSION_MINOR}.${NANOFLANN_VERSION_PATCH}")
 
-
-# Compiler options:
-set(CMAKE_CXX_STANDARD 11)
-set(CMAKE_CXX_STANDARD_REQUIRED ON)
-
 # Enable a high level of warnings.
 if (CMAKE_COMPILER_IS_GNUCXX)
 	# The -Wno-long-long is required in 64bit systems when including sytem headers.
@@ -41,23 +36,40 @@
 endif()
 
 # Solution Folder options:
-set_property(GLOBAL PROPERTY USE_FOLDERS ON)
-set_property(GLOBAL PROPERTY PREDEFINED_TARGETS_FOLDER "CMakeTargets")
+if (${CMAKE_SOURCE_DIR} STREQUAL ${PROJECT_SOURCE_DIR})
+	set_property(GLOBAL PROPERTY USE_FOLDERS ON)
+	set_property(GLOBAL PROPERTY PREDEFINED_TARGETS_FOLDER "CMakeTargets")
+endif()
 
 add_definitions ( -DNANOFLANN_PATH="${CMAKE_SOURCE_DIR}" )
 
+include(GNUInstallDirs)
+if ($ENV{VERBOSE})
+	message(STATUS "CMAKE_INSTALL_INCLUDEDIR: ${CMAKE_INSTALL_INCLUDEDIR}")
+	message(STATUS "CMAKE_INSTALL_DATADIR   : ${CMAKE_INSTALL_DATADIR}")
+	message(STATUS "CMAKE_INSTALL_LIBDIR    : ${CMAKE_INSTALL_LIBDIR}")
+	message(STATUS "CMAKE_INSTALL_DOCDIR    : ${CMAKE_INSTALL_DOCDIR}")
+	message(STATUS "CMAKE_INSTALL_PREFIX    : ${CMAKE_INSTALL_PREFIX}")
+endif()
 
-include(GNUInstallDirs)
 # Set relative install directories
 set(INSTALL_INCLUDE_DIR "${CMAKE_INSTALL_INCLUDEDIR}")
-set(INSTALL_PKGCONFIG_DIR "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
-set(INSTALL_CMAKE_DIR "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}")
+set(INSTALL_CMAKE_DIR "${CMAKE_INSTALL_DATADIR}/${PROJECT_NAME}/cmake/")
 set(INSTALL_COPYRIGHT_DIR "${CMAKE_INSTALL_DOCDIR}")
-
+if(NOT DEFINED PKGCONFIG_INSTALL_DIR)
+  set(PKGCONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
+endif()
 
 # Define nanoflann lib (header-only)
 add_library(nanoflann INTERFACE)
 
+# Tell CMake which C++ features we need
+target_compile_features(nanoflann
+	INTERFACE
+		cxx_auto_type
+		cxx_decltype
+		cxx_deleted_functions
+)
 target_include_directories(nanoflann
 	INTERFACE
 		$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
@@ -69,14 +81,14 @@
 add_library(nanoflann::nanoflann ALIAS nanoflann)
 
 # Examples
-option(BUILD_EXAMPLES "Build examples" ON)
-if(BUILD_EXAMPLES)
+option(NANOFLANN_BUILD_EXAMPLES "Build examples" ON)
+if(NANOFLANN_BUILD_EXAMPLES)
 	add_subdirectory(examples)
 endif()
 
 # Benchmarks
-option(BUILD_BENCHMARKS "Build benchmarks" OFF)
-if(BUILD_BENCHMARKS)
+option(NANOFLANN_BUILD_BENCHMARKS "Build benchmarks" OFF)
+if(NANOFLANN_BUILD_BENCHMARKS)
         # 3rdparty Libraries
         include(3rdparty/CMakeLists-flann.txt)
         include(3rdparty/CMakeLists-fastann.txt)
@@ -85,8 +97,8 @@
 endif()
 
 # Tests
-option(BUILD_TESTS "Build unit tests" ON)
-if(BUILD_TESTS)
+option(NANOFLANN_BUILD_TESTS "Build unit tests" ON)
+if(NANOFLANN_BUILD_TESTS)
 	enable_testing()
 	add_subdirectory(tests)
 endif()
@@ -95,27 +107,13 @@
 # Install/uninstall targets
 # --------------------------------------------------------------------
 
-#--------------------------------------------------------------
-# If we are building the final step of the Debian package,
-#  save each library files in the corresponding directories:
-#--------------------------------------------------------------
-if(CMAKE_USE_DEB_POSTFIXS)
-	# Values when building a Debian package ---------------
-	message(STATUS "** Using Debian post-fix for install directories **")
-	set(libnanoflann_dev_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}/libnanoflann-dev/usr/")
-	set(nanoflann_pkgconfig_INSTALL_PREFIX "/usr")	# Values when building a Debian package
-ELSE()
-	# Values under normal conditions -----------------------
-	set(libnanoflann_dev_INSTALL_PREFIX "")
-	set(nanoflann_pkgconfig_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}") 	# Values under normal conditions
-endif()
+# Variable for pkgconfig file:
+set(nanoflann_pkgconfig_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}")
 
 # Generate the pkg-config file:
 configure_file(
 	"${nanoflann_SOURCE_DIR}/scripts/nanoflann.pc.in"
 	"${nanoflann_BINARY_DIR}/nanoflann.pc" @ONLY IMMEDIATE )
-
-
 
 # Generate the cmake config and cmake config-version file:
 include(CMakePackageConfigHelpers)
@@ -146,9 +144,14 @@
   "${nanoflann_BINARY_DIR}/cmake_uninstall.cmake"
   @ONLY IMMEDIATE)
 
-add_custom_target(uninstall
-  "${CMAKE_COMMAND}" -P "${nanoflann_BINARY_DIR}/cmake_uninstall.cmake")
-
+if (NOT TARGET uninstall)
+  add_custom_target(uninstall
+    "${CMAKE_COMMAND}" -P "${nanoflann_BINARY_DIR}/cmake_uninstall.cmake")
+else()
+  add_custom_target(nanoflann_uninstall
+    "${CMAKE_COMMAND}" -P "${nanoflann_BINARY_DIR}/cmake_uninstall.cmake")
+  add_dependencies(uninstall nanoflann_uninstall)
+endif()
 
 export(EXPORT nanoflannTargets
        NAMESPACE nanoflann::
@@ -158,23 +161,17 @@
 
 install(EXPORT nanoflannTargets
         NAMESPACE nanoflann::
-        DESTINATION "${libnanoflann_dev_INSTALL_PREFIX}${INSTALL_CMAKE_DIR}")
+        DESTINATION "${INSTALL_CMAKE_DIR}")
 
 install(
 	FILES "${nanoflann_BINARY_DIR}/nanoflann.pc"
-	DESTINATION "${libnanoflann_dev_INSTALL_PREFIX}${INSTALL_PKGCONFIG_DIR}" )
+	DESTINATION "${PKGCONFIG_INSTALL_DIR}" )
 
 install(
     FILES "${nanoflann_BINARY_DIR}/nanoflannConfig.cmake"
           "${nanoflann_BINARY_DIR}/nanoflannConfigVersion.cmake"
-    DESTINATION "${libnanoflann_dev_INSTALL_PREFIX}${INSTALL_CMAKE_DIR}" )
+    DESTINATION "${INSTALL_CMAKE_DIR}" )
 
 install(
 	FILES "${nanoflann_SOURCE_DIR}/include/nanoflann.hpp"
-	DESTINATION "${libnanoflann_dev_INSTALL_PREFIX}${INSTALL_INCLUDE_DIR}" )
-
-if(CMAKE_USE_DEB_POSTFIXS)
-	install(
-		FILES "${nanoflann_SOURCE_DIR}/copyright"
-		DESTINATION "${libnanoflann_dev_INSTALL_PREFIX}${INSTALL_COPYRIGHT_DIR}" )
-endif()
+	DESTINATION "${INSTALL_INCLUDE_DIR}" )

=== benchmarkTool/realTests/CMakeLists.txt ===
--- 
+++ 
@@ -3,11 +3,23 @@
 ADD_DEPENDENCIES(benchmarks benchmark_nanoflann_real)
 
 
+# Since flann 1.8.5, LZ4 is vendored. Building against this version fails.
+# This explicitly states to use the system's version of LZ4 instead.
+# See: https://github.com/mariusmuja/flann/issues/384#issuecomment-668782051
+MESSAGE(STATUS "Finding LZ4 libraries")
+FIND_LIBRARY(LZ4_LIBRARIES NAMES liblz4.so HINTS "lz4/lib")
+IF(LZ4_LIBRARIES)
+    MESSAGE(STATUS "Found: ${LZ4_LIBRARIES}")
+    ELSE()
+    MESSAGE(STATUS "Not found: ${LZ4_LIBRARIES}")
+    MESSAGE(FATAL_ERROR "Cannot find required LZ4 libraries")
+ENDIF()
+
 set(flann_INCLUDE_DIRS "${CMAKE_SOURCE_DIR}/3rdparty/flann/src/cpp")
 include_directories(${flann_INCLUDE_DIRS})
 set(flann_LIBRARIES "${CMAKE_SOURCE_DIR}/build/flann-prefix/src/flann-build/lib/libflann_cpp.so")
 ADD_EXECUTABLE(benchmark_flann_real benchmark_flann_real.cpp)
-TARGET_LINK_LIBRARIES(benchmark_flann_real nanoflann::nanoflann ${flann_LIBRARIES})
+TARGET_LINK_LIBRARIES(benchmark_flann_real nanoflann::nanoflann ${flann_LIBRARIES} ${LZ4_LIBRARIES})
 ADD_DEPENDENCIES(benchmark_flann_real flann)
 ADD_DEPENDENCIES(benchmarks benchmark_flann_real)

=== debian/changelog ===
nanoflann (1.4.3+ds-2) unstable; urgency=medium

  * Avoid conflicts with None macro from X11.h (Closes: #1016245)

 -- Timo Röhling <roehling@debian.org>  Mon, 01 Aug 2022 18:17:42 +0200

nanoflann (1.4.3+ds-1) unstable; urgency=medium

  * New upstream version 1.4.3+ds
  * Bump Standards-Version to 4.6.1

 -- Timo Röhling <roehling@debian.org>  Wed, 27 Jul 2022 11:19:08 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders: Timo Röhling <roehling@debian.org>, José Luis Blanco Claraco <joseluisblancoc@gmail.com>
 Build-Depends: debhelper-compat (= 13), cmake, libgtest-dev <!nocheck>, doxygen <!nodoc>
 Homepage: https://github.com/jlblancoc/nanoflann
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/science-team/nanoflann.git
 Vcs-Browser: https://salsa.debian.org/science-team/nanoflann

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v(\d\S+)\.tar\.gz/nanoflann-$1\.tar\.gz/,\
     dversionmangle=s/\+ds\d*$//,oversionmangle=s/$/+ds/,\
     repack \
https://github.com/jlblancoc/nanoflann/releases/latest .*/v(\d\S+)\.tar\.gz

## nanoflann 1.5.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -24,7 +24,10 @@
 if (CMAKE_COMPILER_IS_GNUCXX)
 	# The -Wno-long-long is required in 64bit systems when including sytem headers.
 	# The -Wno-variadic-macros was needed for Eigen3, StdVector.h
-	add_compile_options(-Wall -Wno-long-long -Wno-variadic-macros -O2 -mtune=native)
+	add_compile_options(-Wall -Wshadow -Wno-long-long -Wno-variadic-macros)
+	if (NOT "${CMAKE_BUILD_TYPE}" STREQUAL "Debug")
+		add_compile_options(-O2 -mtune=native)
+	endif()
 	# Workaround: Eigen <3.4 produces *tons* of warnings in GCC >=6. See http://eigen.tuxfamily.org/bz/show_bug.cgi?id=1221
 	if (NOT ${CMAKE_CXX_COMPILER_VERSION} LESS "6.0")
 		add_compile_options(-Wno-ignored-attributes -Wno-int-in-bool-context)
@@ -60,6 +63,9 @@
   set(PKGCONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
 endif()
 
+# Save all executables (unit tests & examples) in the same place:
+set(EXECUTABLE_OUTPUT_PATH ${${PROJECT_NAME}_BINARY_DIR}/bin CACHE PATH "Output directory for executables")
+
 # Define nanoflann lib (header-only)
 add_library(nanoflann INTERFACE)
 
@@ -78,22 +84,18 @@
 install(TARGETS nanoflann
         EXPORT nanoflannTargets)
 
+# Since 2023-March, the parallel KD tree construction feature 
+# needs pthreads for gcc:
+find_package(Threads)
+target_link_libraries(nanoflann INTERFACE Threads::Threads)
+
+
 add_library(nanoflann::nanoflann ALIAS nanoflann)
 
 # Examples
 option(NANOFLANN_BUILD_EXAMPLES "Build examples" ON)
 if(NANOFLANN_BUILD_EXAMPLES)
 	add_subdirectory(examples)
-endif()
-
-# Benchmarks
-option(NANOFLANN_BUILD_BENCHMARKS "Build benchmarks" OFF)
-if(NANOFLANN_BUILD_BENCHMARKS)
-        # 3rdparty Libraries
-        include(3rdparty/CMakeLists-flann.txt)
-        include(3rdparty/CMakeLists-fastann.txt)
-        include(3rdparty/CMakeLists-libkdtree.txt)
-	add_subdirectory(benchmarkTool)
 endif()
 
 # Tests

=== examples/examples_gui/nanoflann_gui_example_R3/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(nanoflann_gui_example_R3)

find_package(nanoflann REQUIRED)
find_package(mrpt-gui REQUIRED)

add_executable(${PROJECT_NAME} ${PROJECT_NAME}.cpp)

# optimized build:
if (CMAKE_COMPILER_IS_GNUCXX)
	target_compile_options(${PROJECT_NAME} PRIVATE -O2 -mtune=native)
endif()

# Make sure the include path is used:
target_link_libraries(${PROJECT_NAME} nanoflann::nanoflann mrpt::gui)

# for this example to find "../utils.h"
target_include_directories(${PROJECT_NAME} PRIVATE ".")

=== debian/changelog ===
nanoflann (1.5.0+ds-1) unstable; urgency=medium

  * Fix d/watch
  * New upstream version 1.5.0+ds
  * Refresh patches
    - Drop 0003-Avoid-conflicts-when-included-together-with-X11.h.patch
      (merged upstream)
  * Bump Standards-Version to 4.6.2
  * Bump cmake_minimum_required() in autopkgtest

 -- Timo Röhling <roehling@debian.org>  Sun, 18 Jun 2023 23:07:35 +0200

## nanoflann 1.5.4+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -57,14 +57,22 @@
 
 # Set relative install directories
 set(INSTALL_INCLUDE_DIR "${CMAKE_INSTALL_INCLUDEDIR}")
-set(INSTALL_CMAKE_DIR "${CMAKE_INSTALL_DATADIR}/${PROJECT_NAME}/cmake/")
+set(INSTALL_CMAKE_DIR "${CMAKE_INSTALL_DATADIR}/cmake/${PROJECT_NAME}")
 set(INSTALL_COPYRIGHT_DIR "${CMAKE_INSTALL_DOCDIR}")
 if(NOT DEFINED PKGCONFIG_INSTALL_DIR)
   set(PKGCONFIG_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
 endif()
 
-# Save all executables (unit tests & examples) in the same place:
-set(EXECUTABLE_OUTPUT_PATH ${${PROJECT_NAME}_BINARY_DIR}/bin CACHE PATH "Output directory for executables")
+if (${CMAKE_CURRENT_SOURCE_DIR} STREQUAL ${CMAKE_SOURCE_DIR})
+	# This is the root project
+	set(MASTER_PROJECT ON)
+else()
+	set(MASTER_PROJECT OFF)
+endif()
+if (MASTER_PROJECT)
+	# Save all executables (unit tests & examples) in the same place:
+	set(EXECUTABLE_OUTPUT_PATH ${${PROJECT_NAME}_BINARY_DIR}/bin CACHE PATH "Output directory for executables")
+endif()
 
 # Define nanoflann lib (header-only)
 add_library(nanoflann INTERFACE)
@@ -84,7 +92,7 @@
 install(TARGETS nanoflann
         EXPORT nanoflannTargets)
 
-# Since 2023-March, the parallel KD tree construction feature 
+# Since 2023-March, the parallel KD tree construction feature
 # needs pthreads for gcc:
 find_package(Threads)
 target_link_libraries(nanoflann INTERFACE Threads::Threads)
@@ -100,6 +108,7 @@
 
 # Tests
 option(NANOFLANN_BUILD_TESTS "Build unit tests" ON)
+option(NANOFLANN_USE_SYSTEM_GTEST "Use system GTest dependency" OFF)
 if(NANOFLANN_BUILD_TESTS)
 	enable_testing()
 	add_subdirectory(tests)
@@ -146,7 +155,9 @@
   "${nanoflann_BINARY_DIR}/cmake_uninstall.cmake"
   @ONLY IMMEDIATE)
 
-if (NOT TARGET uninstall)
+option(MASTER_PROJECT_HAS_TARGET_UNINSTALL "uninstall target to master project CMakeLists.txt" OFF)
+
+if(NOT MASTER_PROJECT_HAS_TARGET_UNINSTALL OR NOT TARGET uninstall)
   add_custom_target(uninstall
     "${CMAKE_COMMAND}" -P "${nanoflann_BINARY_DIR}/cmake_uninstall.cmake")
 else()

=== examples/examples_gui/nanoflann_gui_example_bearings/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(nanoflann_gui_example_bearings)

find_package(nanoflann REQUIRED)
find_package(mrpt-gui REQUIRED)

add_executable(${PROJECT_NAME} ${PROJECT_NAME}.cpp)

# optimized build:
if (CMAKE_COMPILER_IS_GNUCXX)
	target_compile_options(${PROJECT_NAME} PRIVATE -O2 -mtune=native)
endif()

# Make sure the include path is used:
target_link_libraries(${PROJECT_NAME} nanoflann::nanoflann mrpt::gui)

=== debian/changelog ===
nanoflann (1.5.4+ds-1) unstable; urgency=medium

  * New upstream version 1.5.4+ds
  * Update patches
    - Drop 0001-Use-system-gtest.patch (obsolete)
    - Drop 0003-Look-for-Threads-dependency-in-CMake-config-script.patch
      (merged upstream)
  * Use new NANOFLANN_USE_SYSTEM_GTEST option
  * Modernize autopkgtest

 -- Timo Röhling <roehling@debian.org>  Wed, 17 Jan 2024 17:11:26 +0100

nanoflann (1.5.3+ds-2) unstable; urgency=medium

  * Remove obsolete cmake -DNANOFLANN_BUILD_BENCHMARKS=OFF argument
  * Look for Threads dependency in CMake config script (Closes: #1058950)

 -- Timo Röhling <roehling@debian.org>  Mon, 18 Dec 2023 23:55:51 +0100

nanoflann (1.5.3+ds-1) unstable; urgency=medium

  * New upstream version 1.5.3+ds

 -- Timo Röhling <roehling@debian.org>  Mon, 11 Dec 2023 16:07:44 +0100

nanoflann (1.5.2+ds-1) unstable; urgency=medium

  * New upstream version 1.5.2+ds
  * Update d/copyright

 -- Timo Röhling <roehling@debian.org>  Fri, 01 Dec 2023 16:38:46 +0100

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders: Timo Röhling <roehling@debian.org>, José Luis Blanco Claraco <joseluisblancoc@gmail.com>
 Build-Depends: debhelper-compat (= 13), cmake, libgtest-dev <!nocheck>, doxygen <!nodoc>
 Homepage: https://github.com/jlblancoc/nanoflann
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/science-team/nanoflann.git
 Vcs-Browser: https://salsa.debian.org/science-team/nanoflann

=== debian/rules ===
--- 
+++ 
@@ -10,8 +10,8 @@
 	dh_auto_configure -- \
 		-DPKGCONFIG_INSTALL_DIR=share/pkgconfig \
 		-DNANOFLANN_BUILD_EXAMPLES=OFF \
-		-DNANOFLANN_BUILD_BENCHMARKS=OFF \
-		-DNANOFLANN_BUILD_TESTS=$(BUILD_TESTS)
+		-DNANOFLANN_BUILD_TESTS=$(BUILD_TESTS) \
+		-DNANOFLANN_USE_SYSTEM_GTEST=ON
 
 execute_after_dh_auto_build:
 ifeq ($(filter nodoc,$(DEB_BUILD_OPTIONS)),)

=== debian/tests/control ===
Tests: run-unit-test
Depends: libnanoflann-dev, libgtest-dev, cmake, g++ | c++-compiler
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts=searchmode=plain,filenamemangle=s%(?:.*?/)?v?@ANY_VERSION@%@PACKAGE@-$1.tar.gz%,\
 dversionmangle=auto,oversionmangle=s%$%+ds%,repack \
 https://api.github.com/repos/jlblancoc/nanoflann/tags \
 tarball/(?:[^"]*?/)?v?@ANY_VERSION@

## nanoflann 1.5.5+ds

=== debian/changelog ===
nanoflann (1.5.5+ds-1) unstable; urgency=medium

  * New upstream version 1.5.5+ds

 -- Timo Röhling <roehling@debian.org>  Fri, 15 Mar 2024 20:40:19 +0100

## nanoflann 1.6.0+ds

=== debian/changelog ===
nanoflann (1.6.0+ds-1) unstable; urgency=medium

  * New upstream version 1.6.0+ds
  * Reformat control files with wrap-and-sort
  * Bump Standards-Version to 4.7.0

 -- Timo Röhling <roehling@debian.org>  Mon, 22 Jul 2024 21:10:28 +0200

=== debian/control ===
Source: nanoflann
Section: libs
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Timo Röhling <roehling@debian.org>,
 José Luis Blanco Claraco <joseluisblancoc@gmail.com>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 doxygen <!nodoc>,
 libgtest-dev <!nocheck>,
Homepage: https://github.com/jlblancoc/nanoflann
Standards-Version: 4.7.0
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/science-team/nanoflann.git
Vcs-Browser: https://salsa.debian.org/science-team/nanoflann

Package: libnanoflann-dev
Section: libdevel
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: C++11 header-only library for Nearest Neighbor Search with KD-Trees
 Nanoflann is a fork of the FLANN library. Originally born as a child project
 of the Mobile Robot Programming Toolkit, nanoflann is now available as
 stand-alone library.
 .
 It trades some of the flexibility of FLANN for raw execution speed and is much
 more memory efficient, as it avoids unnecessary copies of point cloud data.

=== debian/tests/control ===
Tests: run-unit-test
Depends:
 cmake,
 g++ | c++-compiler,
 libgtest-dev,
 libnanoflann-dev,
Restrictions: allow-stderr

## nanoflann 1.6.1+ds

=== debian/changelog ===
nanoflann (1.6.1+ds-1) unstable; urgency=medium

  * New upstream version 1.6.1+ds

 -- Timo Röhling <roehling@debian.org>  Tue, 27 Aug 2024 23:57:34 +0200

## nanoflann 1.6.3+ds

=== debian/changelog ===
nanoflann (1.6.3+ds-1) unstable; urgency=medium

  * New upstream version 1.6.3+ds
  * Wrap and sort Debian package files
  * Bump copyright years in d/copyright

 -- Timo Röhling <roehling@debian.org>  Sat, 11 Jan 2025 23:59:14 +0100

nanoflann (1.6.2+ds-1) unstable; urgency=medium

  * Update d/watch to latest GitHub recipe
  * New upstream version 1.6.2+ds

 -- Timo Röhling <roehling@debian.org>  Fri, 08 Nov 2024 21:25:21 +0100

## nanoflann 1.7.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # ----------------------------------------------------------------------------
 # Root CMake file for nanoflann
 # ----------------------------------------------------------------------------
-cmake_minimum_required(VERSION 3.1)
+cmake_minimum_required(VERSION 3.10)
 
 # Extract library version into "NANOFLANN_VERSION"
 # -----------------------------------------------------

=== examples/examples_gui/nanoflann_gui_example_R3/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(nanoflann_gui_example_R3)

find_package(nanoflann REQUIRED)
find_package(mrpt-gui REQUIRED)

add_executable(${PROJECT_NAME}_radius ${PROJECT_NAME}.cpp)
add_executable(${PROJECT_NAME}_knn ${PROJECT_NAME}.cpp)
add_executable(${PROJECT_NAME}_rknn ${PROJECT_NAME}.cpp)

target_compile_definitions(${PROJECT_NAME}_radius PRIVATE USE_RADIUS_SEARCH)
target_compile_definitions(${PROJECT_NAME}_knn PRIVATE USE_KNN_SEARCH)
target_compile_definitions(${PROJECT_NAME}_rknn PRIVATE USE_RKNN_SEARCH)

# optimized build:
if (CMAKE_COMPILER_IS_GNUCXX)
	target_compile_options(${PROJECT_NAME}_radius PRIVATE -O2 -mtune=native)
	target_compile_options(${PROJECT_NAME}_knn PRIVATE -O2 -mtune=native)
	target_compile_options(${PROJECT_NAME}_rknn PRIVATE -O2 -mtune=native)
endif()

# Make sure the include path is used:
target_link_libraries(${PROJECT_NAME}_radius nanoflann::nanoflann mrpt::gui)
target_link_libraries(${PROJECT_NAME}_knn nanoflann::nanoflann mrpt::gui)
target_link_libraries(${PROJECT_NAME}_rknn nanoflann::nanoflann mrpt::gui)

# for this example to find "../utils.h"
target_include_directories(${PROJECT_NAME}_radius PRIVATE ".")
target_include_directories(${PROJECT_NAME}_knn PRIVATE ".")
target_include_directories(${PROJECT_NAME}_rknn PRIVATE ".")

=== debian/changelog ===
nanoflann (1.7.0+ds-1) unstable; urgency=medium

  * New upstream version 1.7.0+ds

 -- Timo Röhling <roehling@debian.org>  Mon, 10 Feb 2025 21:30:03 +0100

=== debian/control ===
--- 
+++ 
@@ -6,8 +6,8 @@
  Timo Röhling <roehling@debian.org>,
  José Luis Blanco Claraco <joseluisblancoc@gmail.com>,
 Build-Depends:
+ debhelper-compat (= 13),
  cmake,
- debhelper-compat (= 13),
  doxygen <!nodoc>,
  libgtest-dev <!nocheck>,
 Homepage: https://github.com/jlblancoc/nanoflann

=== debian/tests/control ===
Tests:
 run-unit-test,
Depends:
 cmake,
 g++ | c++-compiler,
 libgtest-dev,
 libnanoflann-dev,
Restrictions:
 allow-stderr,

## nanoflann 1.7.1+ds

=== debian/changelog ===
nanoflann (1.7.1+ds-1) unstable; urgency=medium

  * New upstream version 1.7.1+ds
  * Bump Standards-Version to 4.7.2

 -- Timo Röhling <roehling@debian.org>  Tue, 01 Apr 2025 21:14:38 +0200

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
  doxygen <!nodoc>,
  libgtest-dev <!nocheck>,
 Homepage: https://github.com/jlblancoc/nanoflann
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/science-team/nanoflann.git
 Vcs-Browser: https://salsa.debian.org/science-team/nanoflann

=== debian/watch ===
version=4
opts=\
 filenamemangle=s%.*/@ANY_VERSION@%@PACKAGE@-$1.tar.gz%,\
 downloadurlmangle=s%(api.github.com/repos/[^/]+/[^/]+)/git/refs/%$1/tarball/refs/%g,\
 dversionmangle=auto,oversionmangle=s%$%+ds%,repack,\
 searchmode=plain \
 https://api.github.com/repos/jlblancoc/nanoflann/git/matching-refs/tags/ \
 https://api.github.com/repos/[^/]+/[^/]+/git/refs/tags/@ANY_VERSION@
